VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "SHDOCVW.dll"
Object = "{48E59290-9880-11CF-9754-00AA00C00908}#1.0#0"; "msinet.ocx"
Begin VB.Form Form1 
   BackColor       =   &H00C0FFC0&
   Caption         =   "Form1"
   ClientHeight    =   6675
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8865
   LinkTopic       =   "Form1"
   ScaleHeight     =   6675
   ScaleWidth      =   8865
   StartUpPosition =   3  'Windows Default
   Begin InetCtlsObjects.Inet inetDownload 
      Left            =   5760
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
   End
   Begin SHDocVwCtl.WebBrowser wbrWebSite 
      Height          =   2775
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   4455
      ExtentX         =   7858
      ExtentY         =   4895
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   "http:///"
   End
   Begin VB.TextBox txtDirectory 
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Text            =   "Text1"
      Top             =   480
      Width           =   4455
   End
   Begin VB.CommandButton cmdSaveImages 
      Caption         =   "Save"
      Height          =   285
      Left            =   4680
      TabIndex        =   2
      Top             =   480
      Width           =   615
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   285
      Left            =   4680
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox txtUrl 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "http://www.vb-helper.com/online_articles.html"
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label lblFile 
      BackStyle       =   0  'Transparent
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   6360
      Width           =   5535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Note: I had trouble with the Web Browser control, apparently due to
' a change in the way MS handles its code as of IE 7. For example, see:
'     http://social.msdn.microsoft.com/Forums/en-US/iewebdevelopment/thread/21935021-1dc7-445b-a829-b02489009aab
'
' To fix it, I right-clicked on the Toolbox and selected Components.
' I clicked the Browse button and selected shdocvw.dll in my System32
' directory. That version of the control seems to work.

' Also add the Internet Transfer Control to the toolbox.

' Add a reference to "Microsoft HTML Object library"
' (C:\WINDOWS\system32\mshtml.tlb).

Private m_Running As Boolean

Private Sub cmdGo_Click()
    On Error GoTo BadNavigate
    wbrWebSite.Navigate txtUrl.Text
    Exit Sub

BadNavigate:
    MsgBox "Error navigating to web site " & _
        txtUrl.Text & vbCrLf & Err.Description, _
        vbOKOnly Or vbExclamation, "Navigation Error"
End Sub
    
Private Sub cmdSaveImages_Click()
Dim doc As HTMLDocument
Dim element As HTMLImg
Dim dir_name As String

    If cmdSaveImages.Caption = "Save" Then
        Me.MousePointer = vbHourglass
        cmdSaveImages.Caption = "Stop"
        cmdGo.Enabled = False
        DoEvents

        ' List the images on this page.
        dir_name = txtDirectory.Text
        If Right$(dir_name, 1) <> "\" Then dir_name = dir_name & "\"

        Set doc = wbrWebSite.Document
        m_Running = True

        For Each element In doc.images
            DownloadPicture dir_name, element.src

            DoEvents
            If Not m_Running Then Exit For
        Next element

        m_Running = False
        cmdSaveImages.Caption = "Save"
        cmdGo.Enabled = True
        Me.MousePointer = vbDefault
        lblFile.Caption = "Done"
        Beep
    Else
        m_Running = False
    End If
End Sub

Private Sub Form_Load()
Dim dir_name As String

    wbrWebSite.Navigate "http://www.vb-helper.com/online_articles.html"

    dir_name = App.Path
    If Right$(dir_name, 1) <> "\" Then dir_name = dir_name & "\"
    dir_name = dir_name & "Pictures\"
    txtDirectory.Text = dir_name

    m_Running = False
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    cmdGo.Left = ScaleWidth - cmdGo.Width - 120
    cmdSaveImages.Left = cmdGo.Left

    wid = cmdGo.Left - txtUrl.Left - 120
    If wid < 120 Then wid = 120
    txtUrl.Width = wid
    txtDirectory.Width = wid

    wid = ScaleWidth - 2 * 120
    If wid < 120 Then wid = 120
    lblFile.Width = wid
    lblFile.Top = ScaleHeight - lblFile.Height - 120

    hgt = lblFile.Top - wbrWebSite.Top - 120
    If hgt < 120 Then hgt = 120
    wbrWebSite.Width = wid
    wbrWebSite.Height = hgt
End Sub

Private Sub DownloadPicture(ByVal dir_name As String, ByVal url As String)
Dim file_title As String
Dim file_name As String
Dim pos As Integer
Dim bytes() As Byte
Dim fnum As Integer

    url = Trim$(url)
    If LCase$(Left$(url, 7)) <> "http://" Then url = "http://" & url

    file_title = url
    pos = InStrRev(file_title, "/")
    If pos > 0 Then file_title = Mid$(file_title, pos + 1)
    file_name = dir_name & file_title

    Debug.Print "Copying " & url & " to " & file_name
    lblFile.Caption = file_title
    lblFile.Refresh

    ' Get the file.
    bytes() = inetDownload.OpenURL(url, icByteArray)

    ' Save the file.
    fnum = FreeFile
    Open file_name For Binary Access Write As #fnum
    Put #fnum, , bytes()
    Close #fnum
End Sub
